Index: /palm/trunk/SCRIPTS/mbuild
===================================================================
--- /palm/trunk/SCRIPTS/mbuild	(revision 190)
+++ /palm/trunk/SCRIPTS/mbuild	(revision 191)
@@ -1308,5 +1308,5 @@
 
 #                print ". /usr/share/modules/init/bash; module load mvapich/mvapich-0.9.9-intel; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
-                print ". /usr/share/modules/init/bash; module load mvapich2/1.2rc1-intel; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
+                print ". /usr/share/modules/init/bash; module load mvapich2; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
 
              elif [[ $remote_host = lctit ]]
Index: /palm/trunk/SCRIPTS/mrun
===================================================================
--- /palm/trunk/SCRIPTS/mrun	(revision 190)
+++ /palm/trunk/SCRIPTS/mrun	(revision 191)
@@ -1114,4 +1114,6 @@
                      fi;;
         (ibmy)       queue=parallel;;
+        (lcsgib)     queue=bigq;;
+        (lcsgih)     queue=bigq;;
         (lctit)      queue=sla3;;
         (nech)       queue=none;;
@@ -1387,4 +1389,14 @@
 
 
+    # SOURCE-VERZEICHNIS ZUM AUFSAMMELN DER ZU UEBERSETZENDEN PROGRAMMTEILE
+    # ERZEUGEN. HIERHIN WERDEN SPAETER IM FALL VON BATCH-JOBS AUCH DAS MRUN-
+    # SCRIPTS SOWIE DIE KONFIGURATIONSDATEI KOPIERT
+ if [[ $restart_run != true ]]
+ then
+    rm -rf  SOURCES_FOR_RUN_$fname
+    mkdir   SOURCES_FOR_RUN_$fname
+ fi
+
+
     # ALLE ZU UEBERSETZENDEN PROGRAMMTEILE ZUSAMMENSAMMELN
     # BEI BATCH-JOBS IST DIES NICHT NOETIG, WEIL DIE PROGRAMMTEILE BEREITS DURCH
@@ -1396,10 +1408,4 @@
     [[ "$source_list" = LM ]]  &&  source_list=LOCALLY_MODIFIED
     [[ "$source_list" = WP ]]  &&  source_list=WRITE_PERMIT
-
-    if [[ $restart_run != true ]]
-    then
-       rm -rf  SOURCES_FOR_RUN_$fname
-       mkdir   SOURCES_FOR_RUN_$fname
-    fi
 
 
@@ -2833,8 +2839,5 @@
                 if [[ $host = lcsgih  ||  $host = lcsgib ]]
                 then
-#                   mpirun -machinefile $PBS_NODEFILE -np $ii  a.out  $ROPTS
-                   ulimit -s 30000
-                   ulimit -a
-#                   mpirun_rsh -hostfile $PBS_NODEFILE -np $ii  OMP_NUM_THREADS=$OMP_NUM_THREADS  palm  $ROPTS
+                   ulimit -s 30000   # A too large stack size causes problems
                    export MV2_NUM_PORTS=2
 #                   export MV2_CPU_MAPPING=0:1:2:3
@@ -3767,61 +3770,89 @@
 
 
-       # ABSPEICHERN DER QUELLTEXTE (NUR FALLS UEBERSETZT WERDEN SOLL)
-       # SOWIE GEGEBENENFALLS DES MAKEFILES
-    if [[ $do_compile = true ]]
-    then
-
-       source_catalog=SOURCES_FOR_RUN_$fname
-
-           # UNTERVERZEICHNIS FUER QUELLTEXTE UND MAKEFILE ANLEGEN
-           # MRUN WIRD DIESES VRZEICHNIS UEBER ENVIRONMENT VARIABLE
-           # MITGETEILT (UEBERSTEUERT ANGABE IN KONFIGURATIONSDATEI)
-       echo  "mkdir  SOURCES_FOR_RUN_$fname"                >>  $jobfile
-       echo  "export SOURCES_COMPLETE=true"                 >>  $jobfile
-       echo  "cd     SOURCES_FOR_RUN_$fname"                >>  $jobfile
-
-       for  filename  in  $source_list
-       do
+       # BEREITSTELLUNG VON QUELLTEXTEN, MRUN-SCRIPTS UND KONFIGURATIONS-
+       # DATEI FUER DEN JOB
+    if [[ $( echo $host | cut -c1-5 ) = lcsgi ]]
+    then
+
+          # KONFIGURATIONSDATEI UND MRUN_SCRIPT IN DAS SOURCE-VERZEICHNIS
+          # KOPIEREN
+       if [[ $restart_run != true ]]
+       then
+          cp  $config_file  $working_directory/SOURCES_FOR_RUN_$fname
+          cp  ${PALM_BIN}/$mrun_script_name  $working_directory/SOURCES_FOR_RUN_$fname
+       fi
+
+          # SOURCE-VERZEICHNIS VOM LOKALEN RECHNER PER SCP TRANSFERIEREN
+          echo  "set -x"  >>  $jobfile
+          echo  "scp  -r  $return_username@$return_addres:$working_directory/SOURCES_FOR_RUN_$fname ."  >>  $jobfile
+          # MRUN-SCRIPTS UND KONFIGURATIONSDATEI IN DAS AKTUELLE ARBEITS-
+          # VERZEICHNIS VERSCHIEBEN
+          echo  "mv  SOURCES_FOR_RUN_$fname/$config_file  . "       >>  $jobfile
+          echo  "mv  SOURCES_FOR_RUN_$fname/$mrun_script_name  . "  >>  $jobfile
+          echo  "execute_mrun=true"                                 >>  $jobfile
+          echo  " "                                                 >>  $jobfile
+
+    else
+
+          # ABSPEICHERN DER QUELLTEXTE (NUR FALLS UEBERSETZT WERDEN SOLL)
+          # SOWIE GEGEBENENFALLS DES MAKEFILES
+       if [[ $do_compile = true ]]
+       then
+
+          source_catalog=SOURCES_FOR_RUN_$fname
+
+              # UNTERVERZEICHNIS FUER QUELLTEXTE UND MAKEFILE ANLEGEN
+              # MRUN WIRD DIESES VRZEICHNIS UEBER ENVIRONMENT VARIABLE
+              # MITGETEILT (UEBERSTEUERT ANGABE IN KONFIGURATIONSDATEI)
+          echo  "mkdir  SOURCES_FOR_RUN_$fname"                >>  $jobfile
+          echo  "export SOURCES_COMPLETE=true"                 >>  $jobfile
+          echo  "cd     SOURCES_FOR_RUN_$fname"                >>  $jobfile
+
+          for  filename  in  $source_list
+          do
+                # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
+             echo  "cat > $filename << \"%END%\""              >>  $jobfile
+             cat   $source_catalog/$filename                   >>  $jobfile
+             echo  " "                                         >>  $jobfile
+             echo  "%END%"                                     >>  $jobfile
+             echo  " "                                         >>  $jobfile
+          done
+
              # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
-          echo  "cat > $filename << \"%END%\""              >>  $jobfile
-          cat   $source_catalog/$filename                   >>  $jobfile
+          echo  "cat > Makefile << \"%END%\""               >>  $jobfile
+          cat   $source_catalog/Makefile                    >>  $jobfile
           echo  " "                                         >>  $jobfile
           echo  "%END%"                                     >>  $jobfile
           echo  " "                                         >>  $jobfile
-       done
-
+
+          echo  "cd -  > /dev/null"                         >>  $jobfile
+
+       fi
+
+
+          # ABSPEICHERN DER KONFIGURATIONSDATEI
           # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
-       echo  "cat > Makefile << \"%END%\""               >>  $jobfile
-       cat   $source_catalog/Makefile                    >>  $jobfile
-       echo  " "                                         >>  $jobfile
-       echo  "%END%"                                     >>  $jobfile
-       echo  " "                                         >>  $jobfile
-
-       echo  "cd -  > /dev/null"                         >>  $jobfile
-
-    fi
-
-
-       # ABSPEICHERN DER KONFIGURATIONSDATEI
-       # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
-    echo  "cat > $config_file << \"%END%\""      >>  $jobfile
-    cat   $config_file                           >>  $jobfile
-    echo  "%END%"                                >>  $jobfile
-    echo  " "                                    >>  $jobfile
-
-
-       # ABSPEICHERN DER AKTUELLEN MRUN-VERSION
-       # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
-    echo  "cat > $mrun_script_name <<\"%END%\""  >>  $jobfile
-    cat   ${PALM_BIN}/$mrun_script_name          >>  $jobfile
-    echo  "%END%"                                >>  $jobfile
-    if [[ $host = lctit ]]
-    then
-       echo "sed 's/bin\/ksh/home2\/usr5\/mkanda\/pub\/ksh/' < $mrun_script_name > mrun_new" >>  $jobfile
-       echo "mv  mrun_new  $mrun_script_name"    >>  $jobfile
-    fi
-    echo  "chmod u+x $mrun_script_name"          >>  $jobfile
-    echo  "execute_mrun=true"                    >>  $jobfile
-    echo  " "                                    >>  $jobfile
+       echo  "cat > $config_file << \"%END%\""      >>  $jobfile
+       cat   $config_file                           >>  $jobfile
+       echo  "%END%"                                >>  $jobfile
+       echo  " "                                    >>  $jobfile
+
+
+          # ABSPEICHERN DER AKTUELLEN MRUN-VERSION
+          # ABDECKZEICHEN VERHINDERN, DASS ERSETZUNGEN ERFOLGEN
+       echo  "cat > $mrun_script_name <<\"%END%\""  >>  $jobfile
+       cat   ${PALM_BIN}/$mrun_script_name          >>  $jobfile
+       echo  "%END%"                                >>  $jobfile
+       if [[ $host = lctit ]]
+       then
+          echo "sed 's/bin\/ksh/home2\/usr5\/mkanda\/pub\/ksh/' < $mrun_script_name > mrun_new" >>  $jobfile
+          echo "mv  mrun_new  $mrun_script_name"    >>  $jobfile
+       fi
+       echo  "chmod u+x $mrun_script_name"          >>  $jobfile
+       echo  "execute_mrun=true"                    >>  $jobfile
+       echo  " "                                    >>  $jobfile
+
+    fi
+
 
        # EVTL. BENOETIGTE INPUT-DATEIEN PER FTP HOLEN ODER DEM JOB DIREKT
Index: /palm/trunk/SCRIPTS/subjob
===================================================================
--- /palm/trunk/SCRIPTS/subjob	(revision 190)
+++ /palm/trunk/SCRIPTS/subjob	(revision 191)
@@ -312,6 +312,6 @@
         (ibmy)   queue=parallel; remote_addres=165.132.26.58; submcom=/usr/lpp/LoadL/full/bin/llsubmit;;
 	(lcfimm) remote_addres=172.20.4.2; submcom=/opt/torque/bin/qsub;;
-        (lcsgib) remote_addres=130.73.232.102; submcom=/opt/torque/bin/qsub;;
-        (lcsgih) remote_addres=130.75.4.102; submcom=/opt/torque/bin/qsub;;
+        (lcsgib) queue=smallq; remote_addres=130.73.232.102; submcom=/opt/torque/bin/qsub;;
+        (lcsgih) queue=smallq; remote_addres=130.75.4.102; submcom=/opt/moab/bin/msub;;
         (lctit)  queue=lctit; remote_addres=172.17.75.161; submcom=/n1ge/TITECH_GRID/tools/bin/n1ge;;
         (lcxt4)	 remote_addres=129.177.20.113; submcom=/opt/torque/2.3.0/bin/qsub;;
@@ -350,4 +350,8 @@
         (ibmy)   case  $ndq  in
                      (parallel)                              error=false;;
+                     (*)                                     error=true;;
+                 esac;;
+        (lcsgib|lcsgih)   case  $ndq  in
+                     (testq|smallq|bigq)                     error=false;;
                      (*)                                     error=true;;
                  esac;;
@@ -672,4 +676,11 @@
  then
 
+    if [[ $queue = testq ]]
+    then
+       queue_directive="#PBS -q $queue"
+    else
+       queue_directive=""
+    fi
+
     if [[ $numprocs != 0 ]]
     then
@@ -683,8 +694,9 @@
 #PBS -o $remote_dayfile
 #PBS -j oe
+$queue_directive
 
 . /usr/share/modules/init/bash
 # module load mvapich/mvapich-0.9.9-intel
-module load mvapich2/1.2rc1-intel
+module load mvapich2
 module load netcdf
 export LD_LIBRARY_PATH=/sw/intel/cce/10.1.015/lib:/sw/intel/fce/10.1.015/lib:/sw/dataformats/netcdf/3.6.2/lib:\$LD_LIBRARY_PATH
@@ -941,5 +953,4 @@
           echo "#PBS -l nodes=1:ppn=1"                   >>  $job_to_send
           echo "#PBS -l feature=xe"                      >>  $job_to_send
-          echo "#PBS -l naccesspolicy=shared"            >>  $job_to_send
           echo "#PBS -o \$HOME/job_queue/last_job_transfer_protocol"      >>  $job_to_send
           echo "#PBS -j oe"                        >>  $job_to_send
@@ -1102,10 +1113,5 @@
        if [[ $remote_host != lctit ]]
        then
-          if [[ $remote_host = lcsgih  ||  $remote_host = lcsgib ]]
-          then
-             ssh  $remote_addres  -l $remote_user  "cd $job_catalog; $submcom  -q workq  $job_on_remhost; rm $job_on_remhost"
-          else
-             ssh  $remote_addres  -l $remote_user  "cd $job_catalog; $submcom $job_on_remhost; rm $job_on_remhost"
-          fi
+          ssh  $remote_addres  -l $remote_user  "cd $job_catalog; $submcom $job_on_remhost; rm $job_on_remhost"
        else
              # TIT ERLAUBT NUR DIE AUSFÜHRUNG GANZ BESTIMMTER KOMMANDOS
Index: /palm/trunk/SOURCE/CURRENT_MODIFICATIONS
===================================================================
--- /palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 190)
+++ /palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 191)
@@ -87,4 +87,8 @@
 (init_1d_model)
 
+Subdomain data are read into temporary arrays pf_tmp/pf3d_tmp in order to
+avoid INTEL compiler warnings about (automatic) creation of temporary arrays
+(combine_plot_fields)
+
 advec_s_ups, advec_u_ups, advec_v_ups, advec_w_ups, calc_spectra, check_open, check_parameters, cpu_statistics, data_output_spectra, header, init_1d_model, init_3d_model, modules, netcdf, palm, parin, poisfft, production_e, read_var_list, read_3d_binary, transpose, wall_fluxes, write_var_list, write_3d_binary
 
Index: /palm/trunk/UTIL/combine_plot_fields.f90
===================================================================
--- /palm/trunk/UTIL/combine_plot_fields.f90	(revision 190)
+++ /palm/trunk/UTIL/combine_plot_fields.f90	(revision 191)
@@ -4,4 +4,6 @@
 ! Actual revisions:
 ! -----------------
+! Subdomain data are read into temporary arrays pf_tmp/pf3d_tmp in order to
+! avoid INTEL compiler warnings about (automatic) creation of temporary arrays
 ! Bugfix: three misplaced #endif directives
 !
@@ -109,6 +111,6 @@
     REAL ::  dx, simulated_time
     REAL, DIMENSION(:),   ALLOCATABLE   ::  eta, ho, hu
-    REAL, DIMENSION(:,:), ALLOCATABLE   ::  pf
-    REAL(spk), DIMENSION(:,:,:), ALLOCATABLE ::  pf3d
+    REAL, DIMENSION(:,:), ALLOCATABLE   ::  pf, pf_tmp
+    REAL(spk), DIMENSION(:,:,:), ALLOCATABLE ::  pf3d, pf3d_tmp
 
     PRINT*, ''
@@ -357,5 +359,8 @@
 !
 !--                Read the subdomain grid-point values
-                   READ ( id+110 )  pf(xa:xe,ya:ye)
+                   ALLOCATE( pf_tmp(xa:xe,ya:ye) )
+                   READ ( id+110 )  pf_tmp
+                   pf(xa:xe,ya:ye) = pf_tmp
+                   DEALLOCATE( pf_tmp )
                 ENDIF
                 IF ( id == 0 )  fanz(av) = fanz(av) + 1
@@ -654,5 +659,8 @@
 !--          Read subdomain indices and grid point values
              READ ( id+110, END=999 )  xa, xe, ya, ye, za, ze
-             READ ( id+110 )  pf3d(xa:xe,ya:ye,za:ze)
+             ALLOCATE( pf3d_tmp(xa:xe,ya:ye,za:ze) )
+             READ ( id+110 )  pf3d_tmp
+             pf3d(xa:xe,ya:ye,za:ze) = pf3d_tmp
+             DEALLOCATE( pf3d_tmp )
              IF ( id == 0 )  fanz(av) = fanz(av) + 1
 