Index: /palm/trunk/SCRIPTS/mbuild
===================================================================
--- /palm/trunk/SCRIPTS/mbuild	(revision 195)
+++ /palm/trunk/SCRIPTS/mbuild	(revision 196)
@@ -1307,6 +1307,7 @@
              then
 
-#                print ". /usr/share/modules/init/bash; module load mvapich/mvapich-0.9.9-intel; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
-                print ". /usr/share/modules/init/bash; module load mvapich2; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
+                print ". /usr/share/modules/init/bash; module load mpt; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
+#                print ". /usr/share/modules/init/bash; module load mvapich2/1.2rc1-intel; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
+#                print ". /usr/share/modules/init/bash; module load mvapich2; cd ${remote_md}; echo $make_call_string > LAST_MAKE_CALL; chmod u+x LAST_MAKE_CALL; $make_call_string; [[ \$? != 0 ]] && echo MAKE_ERROR" | ssh  ${remote_username}@${remote_addres} 2>&1 | tee ${remote_host}_last_make_protokoll
 
              elif [[ $remote_host = lctit ]]
Index: /palm/trunk/SCRIPTS/mrun
===================================================================
--- /palm/trunk/SCRIPTS/mrun	(revision 195)
+++ /palm/trunk/SCRIPTS/mrun	(revision 196)
@@ -2840,7 +2840,8 @@
                 then
                    ulimit -s 30000   # A too large stack size causes problems
-                   export MV2_NUM_PORTS=2
+#                   export MV2_NUM_PORTS=2
 #                   export MV2_CPU_MAPPING=0:1:2:3
-                   mpiexec    ./palm  $ROPTS
+#                   mpiexec    ./palm  $ROPTS
+                   mpiexec_mpt -np $ii   ./palm  $ROPTS
                 elif [[ $host = lcxt4 ]]
                 then
Index: /palm/trunk/SCRIPTS/subjob
===================================================================
--- /palm/trunk/SCRIPTS/subjob	(revision 195)
+++ /palm/trunk/SCRIPTS/subjob	(revision 196)
@@ -160,5 +160,5 @@
      (breg*-en0|berni*-en0)  local_addres=130.73.230.10;  local_host=ibmb;;
      (breva)                 local_addres=130.75.105.98;  local_host=lcmuk;;
-     (b01*)                  local_addres=130.73.232.102; local_host=lcsgih;;
+     (b01*)                  local_addres=130.73.232.102; local_host=lcsgib;;
      (compute-*.local)       local_addres=172.20.4.2;     local_host=lcfimm;;
      (cs*)                   local_addres=136.172.44.131; local_host=nech;;
@@ -186,5 +186,5 @@
      (sun1|sun2)             local_addres=130.75.6.1;     local_host=unics;;
      (r1*)                   local_addres=130.75.4.102;   local_host=lcsgih;;
-     (r2*)                   local_addres=130.73.232.102; local_host=lcsgih;;
+     (r2*)                   local_addres=130.73.232.102; local_host=lcsgib;;
      (tgg*)                  local_addres=172.17.75.161;  local_host=lctit;;
      (vorias)                local_addres=172.20.25.43;   local_host=lcmuk;;
@@ -312,5 +312,5 @@
         (ibmy)   queue=parallel; remote_addres=165.132.26.58; submcom=/usr/lpp/LoadL/full/bin/llsubmit;;
 	(lcfimm) remote_addres=172.20.4.2; submcom=/opt/torque/bin/qsub;;
-        (lcsgib) queue=smallq; remote_addres=130.73.232.102; submcom=/opt/torque/bin/qsub;;
+        (lcsgib) queue=smallq; remote_addres=130.73.232.102; submcom=/opt/moab/bin/msub;;
         (lcsgih) queue=smallq; remote_addres=130.75.4.102; submcom=/opt/moab/bin/msub;;
         (lctit)  queue=lctit; remote_addres=172.17.75.161; submcom=/n1ge/TITECH_GRID/tools/bin/n1ge;;
@@ -697,6 +697,7 @@
 
 . /usr/share/modules/init/bash
-# module load mvapich/mvapich-0.9.9-intel
-module load mvapich2
+module load mpt
+# module load mvapich2/1.2rc1-intel
+# module load mvapich2
 module load netcdf
 export LD_LIBRARY_PATH=/sw/intel/cce/10.1.015/lib:/sw/intel/fce/10.1.015/lib:/sw/dataformats/netcdf/3.6.2/lib:\$LD_LIBRARY_PATH